'''''''''''''''''''''''''''''''''''''''''''''''
'                                             '
'                EMPAREJA                     '
'                                             '
'     Presentado al Concurso BASIC 2020       ' 
' (http://www.bytemaniacos.com/?page_id=3639) '
'        Categoria BASIC compilado            '
'                                             '
'         (C) EddieTheWild 2020               '
'                                             '
'''''''''''''''''''''''''''''''''''''''''''''''

#include <memcopy.bas>
#include <input.bas>
#include <keys.bas>
#include <string.bas>
#include <print42.bas>
#include <scroll.bas>


const AnchoGrid as ubyte=4
const AltoGrid as ubyte=3
const FotosGrid as ubyte=AnchoGrid*AltoGrid
const FotosGaleria as ubyte=25
const DimFoto as ubyte=7   ' 6x6 caracteres cada "foto"
const MaxTiempo as ubyte=184
const MinTiempo as ubyte=88

dim galeria(FotosGaleria,DimFoto) as string  'Galeria de "fotos" disponible de 6x6 caracteres
dim fotos(FotosGrid) as ubyte         '6 Fotos seleccionadas para cada partida, cada una 2 veces
dim fotosMostradas(FotosGrid) as ubyte ' 1 si esta visualizada, 0 si oculta


dim sc, hi as ulong

dim tiempo, tiempoPartida, lentitud as uinteger 
' aunque toman valores <256 tengo que declararlas asi o al multiplicar 
' sus valores... trunca el resultado a tipo byte aunque se asigne a 
' una variable uinteger :-((((


'declare SUB selectFotos()
'declare SUB crearGaleria(num as ubyte, anchura as ubyte, altura as ubyte)
'declare SUB muestraFoto(n as ubyte)
'declare SUB barraTiempo(temp as ubyte)
'declare SUB crearUDGs()


' Dibuja la barra vertical de tiempo desde 0 hasta el valor indicado en pixeles (sera multiplo de 8)
' maximo -> constante MaxTiempo)

SUB barraTiempo(temp as ubyte)
    if temp> MaxTiempo then temp=MaxTiempo
    col=4
    for i=23 to 24-temp/8 step -1
      if i<14 then
      	col=4
      elseif i>20 then
      	col=2
      elseif i>15 then
      	col=6
      end if
      print at i,30;paper 0;ink col;"\::";
      beep 0.001,30-i
    next i

END SUB


SUB crearUDGs()
  DIM UDG(20,8) AS UBYTE => {{1,3,7,15,31,63,127,255},{128,192,224,240,248,252,254,255},{255,127,63,31,15,7,3,1},_
	   												 {255,254,252,248,240,224,192,128},{255,128,128,128,128,128,128,128},{255,0,0,0,0,0,0,0},_  
    												 {255,1,1,1,1,1,1,1},{128,128,128,128,128,128,128,255},{0,0,0,0,0,0,0,255},_
			   										 {1,1,1,1,1,1,1,255},{128,128,128,128,128,128,128,128},{1,1,1,1,1,1,1,1},_
														 {16,48,112,255,255,112,48,16},{16,48,112,255,255,112,48,16},{8,12,14,255,255,14,12,8},_
														 {24,60,126,255,24,24,24,24},{24,24,24,24,255,126,60,24},{32,32,56,124,124,124,56,56},_
														 {136,34,136,34,136,34,136,34},{170,85,170,85,170,85,170,85}}
  'POKE UINTEGER 23675, @UDG(1,1) ' no va...
  dir=65368
  for i=0 to 19:for j=0 to 7:poke dir+i*8+j,UDG(i+1,j+1):next j:next i
  'w$="\s\s\s\s\s\s\s"
  'print w$:print "\a\b\c\d\e\f\g\h\i\j\k\l\m\n\o\p\q\r\s\t\u":pause 0
END SUB



' Carga num de anchura x altura en la galeria

SUB crearGaleria(num as ubyte, anchura as ubyte, altura as ubyte)
  randomize
  select$=""
  for i=1 to num
    memCopy(rnd*7000,16384,6144)  ' con color 7168
    beep 0.000005,60
   ' print at 5,10;"Cargando foto ";i;
    do
      s$=""
      c$=chr$(33+95*rnd)
    loop until instr(select$,c$)=0  ' elegimos uno que no se haya elegido ya
    select$=select$+c$
    for j=1 to anchura
      s$=s$+c$
    next j
    for j=1 to altura
      galeria(i,j)=s$
    '  print at 10,5;s$
    next j
  next i
END SUB



' selecciona las fotos de la galeria que formaran el grid de la partida.

SUB selectFotos()
   for i=1 to FotosGrid: fotos(i)=0: next i
   select$=""
   n=1
   for i=1 to 6
   do
       f=int(FotosGaleria*rnd)+1   ' print at 10,1;"foto=";f;" "
       w$=str$(f)+" "
       if f<10 then w$="0"+w$  
   loop until instr(select$,w$)=0
   select$=select$+w$               '  print at 0,0;select$ 
   while fotos(n)<>0 
       n=n+1: ' print at 11,1;"n=";n;" "	
   wend ' la foto elegida ira a continuacion, en la posicion x o la siguiente libre
   fotos(n)=f                       '   print at 15,0;"foto ";f;" a las posiciones ";n;
   n=n+1
   do 
     	  m=int((FotosGrid-n+1)*rnd)+n  ' posicion en la que se colocara su segunda aparicion 
   loop until fotos(m)=0
   fotos(m)=f          ' otra vez la misma   
   next i 
     
/'   print:print "  Elegidos:";select$
   for j=1 to FotosGrid:print fotos(j);"  ";
        if j mod AnchoGrid=0 then print
   next j: pause 0
'/

END SUB

 

' Visualiza la foto n en su posicin, segun dimensiones del grid

SUB muestraFoto(n as ubyte)
   f=fotos(n)
   x=1+((n-1) mod AnchoGrid)*(DimFoto)
   y=1+int((n-1)/AnchoGrid)*(DimFoto)
   for i=1 to DimFoto
      print at y+i-1,x;ink 7;galeria(f,i);
   next i
   fotosMostradas(n)=1
END SUB


' Oculta la foto n en su posicin, segun dimensiones del grid

SUB ocultaFoto(n as ubyte)
   wu$="\e\f\f\f\f\f\g" ' Deben ser de longitud DimFoto
   wm$="\k     \l"
   wb$="\h\i\i\i\i\i\j"  
  ' w$="\s\s\s\s\s\s\s"
   x=1+((n-1) mod AnchoGrid)*(DimFoto)
   y=1+int((n-1)/AnchoGrid)*(DimFoto)
   print ink 2;at y,x;wu$;
   for i=2 to DimFoto-1
      print ink 2;at y+i-1,x;wm$  
   next i
   print ink 2;at y+DimFoto-1,x;wb$;
   fotosMostradas(n)=0
END SUB


dim teclas$(12)

SUB confKeys(k as ubyte) '' ni idea porque no ejecuta esto al invocarlo. Dice empty if ignored...
    if k=1 then
    	 teclas$(1)="1": teclas$(2)="2": teclas$(3)="3": teclas$(4)="4"
       teclas$(5)="q": teclas$(6)="w": teclas$(7)="e": teclas$(8)="r"
       teclas$(9)="a": teclas$(10)="s": teclas$(11)="d": teclas$(12)="f"
    else
       teclas$(1)="12": teclas$(2)="345": teclas$(3)="678": teclas$(4)="90"
       teclas$(5)="qw": teclas$(6)="ert": teclas$(7)="yui": teclas$(8)="op"
       teclas$(9)="as": teclas$(10)="dfg": teclas$(11)="hjk": teclas$(12)="l"+chr$(13)
    end if
END SUB




SUB inicReloj()
  POKE 23672,0: POKE 23673,0: POKE 23674,0
END SUB

  
FUNCTION mostrarReloj() as string
  dim horas, min, seg as ubyte
  dim frames, s as ulong
  dim resto as uinteger
	LET frames=PEEK 23672+256*(PEEK 23673)+65536*(PEEK 23674): LET s=INT (frames/50): LET horas=INT (s/3600): LET resto=s-3600*horas: LET min=INT (resto/60): LET seg=resto-60*min
  w$=str(horas)+" horas, "+str(min)+" min., "+str(seg)+" seg."
  return w$
END FUNCTION



SUB salir()
  BEEP .01,50:
  PRINT INK 6; FLASH 1;at 21,0;"Realmente quieres salir? (s/n)";
  pause 0 
  w$=CHR$ PEEK 23560: 
  BEEP .01,20: 
  IF w$="s" THEN 
  	       CLS : PRINT at 6,1;"Gracias por jugar a 'EMPAREJA'"
  	       print at 8,12;"durante"
  	       print at 10,4;mostrarReloj()
  	       print
  	       print at 14,6;"\* EddieTheWild 2020"
  	       stop
      else 
      	   PRINT PAPER 0; INK 6; FLASH 0;AT 21,0,,
   endif
END SUB


SUB instrucciones(cjtoteclas as ubyte)
   BEEP .01,50: 
   for i=7 to 21:print at i,0;"                                ";:next i
   printat42(8,0):print42("Veremos durante 3 seg. una matriz de 4x3")
   printat42(9,0):print42("fotos (6 fotos repetidas 2 veces).")
   printat42(10,0):print42("Luego se ocultaran y deberas descubrir las")
   printat42(11,0):print42("parejas pulsando en ellas de forma")
   printat42(12,0):print42("consecutiva antes de finalizar el tiempo.")
   print at 14,0;"Teclas:"
   w$=teclas(12):c=8
   if cjtoteclas=2 then 
   	   v$=w$(1)+"<Enter>"
   	   c=c-3
   	    ' para evitar cambiar de linea al mostrar el chr$(13)
     else 
     	 v$=w$
   end if 
   print ink 4;at 15,c;"'";teclas$(1);"' '";teclas$(2);"' '";teclas$(3);"' '";teclas$(4);"'"
   print ink 4;at 16,c;"'";teclas$(5);"' '";teclas$(6);"' '";teclas$(7);"' '";teclas$(8);"'"
   print ink 4;at 17,c;"'";teclas$(9);"' '";teclas$(10);"' '";teclas$(11);"' '";v$+"'"
   
   print at 21,0;"Pulsa una tecla para continuar";
   pause 0 
   w$=CHR$ PEEK 23560: 
   BEEP .01,20: 
   for i=7 to 21:print at i,0;"                                ";:next i
END SUB





' PROGRAMA PRINCIPAL


inic:

   border 1:paper 0:ink 7:cls
  
   keyset=1
   confKeys(keyset)
 
   crearGaleria(FotosGaleria,DimFoto,DimFoto)
   crearUDGs()
   inicReloj()
   
   hi=0

' Titulo
   
  DIM titulo$(5) as string 
  titulo$(1)="\::\::\b \::\b\a\:: \::\::\b \a\::\b \::\::\b \::\::\b \::\::\:: \a\::\b"
  titulo$(2)="\::   \::\c\d\:: \:: \:: \:: \:: \:: \:: \::   \:: \:: \:: \::":
  titulo$(3)="\::\::\:: \::  \:: \::\::\d \::\::\:: \::\::\d \::\::\::   \:: \::\::\::"
  titulo$(4)="\::   \::  \:: \::   \:: \:: \::\c\b \::     \:: \:: \::": 
  titulo$(5)="\::\::\d \::  \:: \::   \:: \:: \:: \:: \::\::\d \::\::\d \:: \::"

  
Menu:
    border 0
    cls
    print at 0,0;
    for i=1 to 5:print ink 1; titulo$(i);:next i
    
menuOpciones: 
    bold 1
    PRINT INK 6;AT 8,6;"1 - Jugar"
    PRINT INK 6;AT 10,6;"2 - Cjto. teclas ";keyset
    PRINT INK 6;AT 12,6;"3 - Ver instrucciones" 
'    print ink 6;at 14,6;"4 - Tabla de records"
    PRINT INK 6;AT 16,6;"0 - Salir"
    bold 0 
    print ink 6;at 23,6;"\* EddieTheWild 2020";
    
leerOpcionMenu:
    pause 0: k$=CHR$ PEEK 23560
    IF k$="1" THEN nivel=1: tiempoPartida=MaxTiempo: sc=0:   lentitud=5: gosub partida: goto Menu
    IF k$="2" THEN keyset=(keyset mod 2)+1:beep .01,50:confKeys(keyset):goto menuOpciones
    IF k$="3" THEN instrucciones(keyset): goto menuOpciones
'    IF k$="4" THEN Records(): goto menuOpciones
    IF k$="0" THEN salir()

   GO TO leerOpcionMenu




 
partida:
   randomize
   border 1
   cls:print ink 7;at 10,12;"Nivel ";nivel
   selectFotos()
   pause 50*2
   cls
   for i=1 to FotosGrid
      muestraFoto(i)
   next i
   barraTiempo(tiempoPartida)
   pause 50*3 ' espera 3 segundos
   for i=1 to FotosGrid
     ocultaFoto(i)
   next i
   for i=5 to 50 step 3: beep 0.001,i:next i:
   for i=50 to 5 step -3: beep 0.001,i:next i
   


  tiempo=tiempoPartida*lentitud    '184 pixeles  
 ' print ink7;at 5,0;"tiempo :";tiempo; " t-part:";tiempoPartida
  foto1=0
  aciertos=0

' Bucle de juego  
  do 
    h$="Record: "+str$(hi)
  	print ink 6;at 23,0;h$;
  	s$="Ptos.: "+str$(sc)
  	print ink 6;at 0,15-len(s$)/2;s$;
  	tiempo=tiempo-1
  '	pause 1 'retardo extra
  	if (tiempo mod lentitud)=0 then plot over 1;paper 8;ink 8;30*8,tiempo/lentitud:draw over 1;paper 8; ink 8;7,0
  	n=0
  	k$=inkey$: if k$="" then goto nuevoCiclo
  	if     instr(teclas$(1),k$)<>0 then
  		 n=1
    elseif instr(teclas$(2),k$)<>0 then
       n=2
    elseif instr(teclas$(3),k$)<>0 then
       n=3
    elseif instr(teclas$(4),k$)<>0 then
       n=4
    elseif instr(teclas$(5),k$)<>0 then
       n=5
    elseif instr(teclas$(6),k$)<>0 then
       n=6
    elseif instr(teclas$(7),k$)<>0 then
       n=7
    elseif instr(teclas$(8),k$)<>0 then
       n=8
    elseif instr(teclas$(9),k$)<>0 then
       n=9
    elseif instr(teclas$(10),k$)<>0 then
       n=10
    elseif instr(teclas$(11),k$)<>0 then
       n=11
    elseif instr(teclas$(12),k$)<>0 then
       n=12
'elseif k$="-" goto fin
    end if
   ' print at 0,0;"foto1=";foto1;"  pulsada=";n
  	if n=0 then goto nuevoCiclo ' han pulsado tecla no valida
  	
  	if fotosMostradas(n)=1 then   ' hemos pinchado en la posicion de una ya mostrada, no hacemos nada
  		  beep 0.0001,40
    else 
       muestraFoto(n)
      if foto1=0 then   'no habia mostrada ninguna
      	    beep 0.001,0: foto1=n
     	elseif fotos(foto1)=fotos(n) then 
     		          aciertos=aciertos+1:beep 0.05,10:beep 0.05,20:foto1=0:sc=sc+50*nivel  ' ES LA MISMA FOTO!! se quedaran abiertas		       
  	         else 
  	         	    beep 0.5,-20:ocultaFoto(foto1):ocultaFoto(n):foto1=0  ' La pinchada no coincide con la ya abierta, ocultamos ambas
  	  end if
    end if

nuevoCiclo:		 
  loop until tiempo<=0 or aciertos=6
fin: 
  for i=1 to 56
  ScrollDown(8,72,231,126)
  next i
  if tiempo<=0 then
    	 Print at 11,10;flash 1;"GAME  OVER"
     	 for i=0 to 8: beep 0.2,-i:next i:beep 1,-9
     	  if sc>hi then 
  	   	   if hi>0 print at 13,4;flash 1;" HAS BATIDO EL RECORD!! "
  	   	   hi=sc
  	   	   beep 0.5,30
  	   	   pause 100
  	   end if	 
     	 return ' Vuelve al menu principal
    else
  	   print at 10,9;flash 1;"ENHORABUENA!!"
  	   for i=1 to 3
  	       for j=1=-10 to 60: beep 0.005,j:next j
  	   next i   
  	   sc=sc+1000*nivel+tiempo/5*nivel 
  	   if sc>hi then 
  	   	   if hi>0 print at 13,4;flash 1;" HAS BATIDO EL RECORD!! "
  	   	   hi=sc
  	   	   beep 0.5,30
  	   	   pause 100
  	   end if	   
  	   if tiempoPartida>MinTiempo then tiempoPartida=tiempoPartida-16 ' decrementamos el tiempo para la proxima partida
  	   if lentitud>1 then lentitud=lentitud-1
  	   nivel=nivel+1
  end if
  goto partida ' continua la partida


